Draft: Serie ortogonale

From FreeCAD Documentation
Revision as of 10:29, 20 May 2021 by FuzzyBot (talk | contribs) (Updating to match new version of source page)
This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft OrthoArray

Posizione nel menu
Modifiche → Strumenti serie → Serie
Ambiente
Draft
Avvio veloce
Nessuno
Introdotto nella versione
0.19
Vedere anche
Serie polare, Serie circolare, Serie su tracciato, Serie di link su tracciato, Serie su punti, Clone

Descrizione

Lo strumento Serie crea una schiera (array) ortogonale (3 assi) o polare utilizzando gli oggetti selezionati.

Questo strumento può essere utilizzato su qualsiasi oggetto che abbia una Part TopoShape, che significa forme 2D create con Draft, ma anche solidi 3D creati con altri ambienti, ad esempio Part, PartDesign o Arch. Può anche creare App Link anziché semplici copie.

This command deprecates the previously existing Array as well as the short lived LinkArray tools.

Una serie ortogonale da un oggetto solido, l'oggetto al centro

Utilizzo

  1. Select the object that you wish to duplicate.
  2. Press the OrthoArray button. If no object is selected, you will be invited to select one.
  3. The task panel is launched, where you can select the number of elements in each X, Y, Z direction; and the interval between each created element.
  4. You can click on the 3D view to set up all the numbers and intervals, and complete the command. Otherwise, just press Enter or the OK button to complete the operation.

Notes

  • Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.
  • This command creates the same parametric "Array" object as the one created with the PolarArray and CircularArray tools. Therefore, the array can be converted to orthogonal, polar, or circular by changing its DatiArray Type property.

Opzioni

These are the options displayed in the task panel.

  • Number of elements: the elements in the X, Y, and Z directions. A copy of the original object is always produced, so this number must be at least 1 in every direction.
  • X intervals: the values of displacement for the copies in the X direction. To create strictly rectangular arrays, the Y and Z values should be zero (x, 0, 0).
  • Y intervals: the values of displacement for the copies in the Y direction. To create strictly rectangular arrays, the X and Z values should be zero (0, y, 0).
  • Z intervals: the values of displacement for the copies in the Z direction. To create strictly rectangular arrays, the X and Y values should be zero (0, 0, z).
  • Reset X, Y, Z: it resets the interval vectors to a rectangular displacement, that is (x, 0, 0), (0, y, 0), and (0, 0, z).
  • Fuse: if it is checked, the resulting objects in the array will fuse together if they touch each other. This only works if Link array is unchecked.
  • Link array: if it is checked, the resulting array will be a "Link array". This array internally uses App Link objects, so it is more efficient when handling many copies of complex shapes. However, in this case, the objects cannot be fused together.
  • Press Esc or the Cancel button to abort the current command.

Note: if a Link array is created, this object cannot be converted to a regular array. And similarly, a regular array cannot be converted to a Link array. Therefore, you must choose the type of array that you want at creation time.

Proprietà

An OrthoArray is derived from a Part Feature (Part::Feature class), therefore it shares all the latter's properties. In addition to the properties described in Part Feature, the OrthoArray has the following properties in the property editor.

Objects

  • DatiArray Type (Enumeration): specifies the type of array to create, "ortho", "polar", or "circular".
  • DatiAxis Reference (LinkGlobal): specifies the object and edge that can be used as reference for polar and circular arrays; for example, it can be the edge of a Wire or a PartDesign DatumLine. If this property exists, it overrides both DatiAxis and DatiCenter, for polar and circular arrays.
  • DatiBase (Link): specifies the object to duplicate in the array.
  • DatiFuse (Bool): it defaults to false; if it is true, and the copies intersect with each other, they will be fused together into a single shape. This only works if the initial array was not a "Link array".

Orthogonal array

  • DatiInterval X (VectorDistance): a vector specifying the interval between each copy on the X axis.
  • DatiInterval Y (VectorDistance): a vector specifying the interval between each copy on the Y axis.
  • DatiInterval Z (VectorDistance): a vector specifying the interval between each copy on the Z axis.
  • DatiNumber X (Integer): the number of copies on the X direction. The DatiBase object counts as one copy; it must be at least 1.
  • DatiNumber Y (Integer): the number of copies on the Y direction.
  • DatiNumber Z (Integer): the number of copies on the Z direction.

Polar/circular array

  • DatiAxis (Vector): the axis direction around which the elements in a polar or circular array are created.
  • DatiCenter (VectorDistance): specifies the center point of the polar or circular array. The DatiAxis passes through this point. For circular arrays, the DatiCenter specifies an offset from the DatiPlacement of the DatiBase object.

Polar array

  • DatiAngle (Angle): specifies the aperture of the circular arc to cover with copies; use 360 to cover an entire circle.
  • DatiInterval Axis (VectorDistance): distance and orientation of each copy in DatiAxis direction.
  • DatiNumber Polar (Integer): number of copies in the polar direction.

Circular array

  • DatiNumber Circles (Integer): the number of circular layers to create. The DatiBase object counts as one layer; it must be at least 1.
  • DatiRadial distance (Distance): the distance between circular layers.
  • DatiSymmetry (Integer): a number that indicates the symmetry lines in the circular layers. This number changes the distribution of the objects and making it very large may eliminate the more central layers.
  • DatiTangential Distance (Distance): the distance between copies in the same circular layer.

Link arrays

In addition to the previous properties, these properties only appear when the array is created as a Link array.

Objects

  • DatiCount (Integer): (read-only) it is the total number of objects in the array including the original object. This property is read-only as the value depends on the other "Number" properties, whether they are orthogonal, polar, or circular.
  • DatiExpand Array (Bool): if it is true, the individual App Link objects will be available to select in the tree view.

Link

  • DatiScale (Float): the scale factor of the entire array.
  • DatiScale List (VectorList): a list of N-vectors determining the individual scaling factor of each of the N-elements in the array, where N is DatiCount.
  • DatiLink Transform (Bool): if it is false it can override the linked object's placement.

Notes

The "Number" properties, whether for orthogonal, polar, or circular arrays, includes the original object, so this value must be at least one.

An interval is not a simple distance, but a vector (x, y, z). If more than one value is non-zero, the copy will be created in the main direction, but will also be displaced in the other non-zero directions.

For example, if DatiInterval X is (2 m, 1 m, 1 m), and DatiNumber X is 3, it will create 3 copies in the X direction; the first copy will be at the original position, the second will be displaced 2 m on X, 1 m on Y, and 1 m on Z; the third copy will be displaced 4 m on X, 2 m on Y, and 2 m on Z. Each array element will be moved slightly to one side (Y direction) and up (Z direction) beside the main X direction.

The DatiInterval Axis property works in the same way. If the original shape lies on the XY plane, creating a polar array with DatiInterval Axis (0, 0, z) allows you to make spiral arrangements, as each copy will be moved a z distance.

Configuration of individual Link objects

Normally, App Link objects are intended to be exact copies of their DatiLinked Object. However, there is a pending feature that will allow configuring individual properties of select App Link copies; this could be useful for Link Arrays. This feature is called a "configuration table".

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

The OrthoArray tool can be used in macros and from the Python console by using the following function.

Older call:

array = makeArray(baseobject, xvector, yvector, zvector, xnum, ynum, znum, use_link=False)

New call:

array = make_ortho_array(base_object,
                         v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0), v_z=App.Vector(0, 0, 10),
                         n_x=2, n_y=2, n_z=1,
                         use_link=True)
array = make_ortho_array2d(base_object,
                           v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0),
                           n_x=2, n_y=2,
                           use_link=True)
  • Creates an "Array" object from the base_object.
    • Instead of a reference to an object, base_object can also be the Label (string) of an object existing in the current document.
    • The vectors v_x, v_y, and v_z determine the distance between the base points of each copy, in the X, Y, and Z directions; and n_x, n_y, and n_z are the number of copies in the respective direction.
    • If use_link is True, the type of array created will be a Link array, whose elements are App Link instances instead of simple copies.
    • make_ortho_array2d ignores the Z component, so the result is going to be a 2D array in the XY plane.
array = make_rect_array(base_object,
                        d_x=10, d_y=10, d_z=10,
                        n_x=2, n_y=2, n_z=1,
                        use_link=True)
array = make_rect_array2d(base_object,
                          d_x=10, d_y=10,
                          n_x=2, n_y=2,
                          use_link=True)
  • The _rect_ variants ignore the off-diagonal components of the v_x, v_y, and v_z vectors, so the arrays will be completely rectangular; the distance between the elements is determined by d_x, d_y, and d_z.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

array = Draft.make_ortho_array2d(rect, v_x, v_y, 3, 4)
doc.recompute()

Scripting, non-parametric array

When using the OrthoArray tool, a parametric "Array" object is created. This can be scripted as described in the previous section.

However, to obtain standalone copies of the base object, the simple Draft.array function can be used. This will create simple copies, not a new parametric object.

To create a rectangular array, use it like this:

array_list = array(objectslist, xvector, yvector, xnum, ynum)
array_list = array(objectslist, xvector, yvector, zvector, xnum, ynum, znum)
  • Creates an array from the objects contained in objectslist, which can be a single object or a list of objects.
    • In case of a rectangular array, xvector, yvector, and zvector determine the distance between the base points of each copy, in the X, Y, and Z directions; and xnum, ynum, and znum are the number of copies in the respective direction.
    • array_list is returned with the new copies. It is either a single object or a list of objects, depending on the input objectslist.

This function internally uses Draft.move() with copy=True.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

array = Draft.array(rect, v_x, v_y, 3, 4)
doc.recompute()